# 1 "lexer.mll"
 

(* Ceci sera utile dans le futur quand on aura un parseur qui definit *)
(* les tokens qu'il souhaite recevoir depuis le lexeur.               *)

open Parser 

open Lexing

(* 
type ast = NUM of int | IDENT of string | STRING of string| DOT | LPAR | RPAR | LCURL | RCURL | LSQ | RSQ | COLON | COMMA | SEMICOLON | PLUS | MINUS | MULT | DIV | ASSIGNS | EQUALS | NE | GTEQ | LTEQ | LT | GT | BEGIN | END | IF | THEN | ELSE | WHILE | FOR | TYPE | LET | ANDLET | AND | OR | TO | DOWNTO | DO | DONE | IN;;
*)

let print_ast = function
          NUM(i) -> print_string ("Num("^(string_of_int i)^") ")
        | IDENT(s) -> print_string ("Ident("^s^") ")
        | CHAR(c) -> print_string ("Ident("^(String.make 1 c)^") ")
        | STRING(s) -> print_string ("String("^s^") ")
        | LPAR -> print_string "LPAR "
	| RPAR -> print_string "RPAR "
	| LCURL -> print_string "LCURL "
	| RCURL -> print_string "RCURL "
	| LSQ -> print_string "LSQ "
	| RSQ -> print_string "RSQ "
	| DOT -> print_string "DOT "
	| COLON -> print_string "COLON "
	| COMMA -> print_string "COMMA "
	| SEMICOLON -> print_string "SEMICOLON "
	| PLUS -> print_string "PLUS "
	| MINUS -> print_string "MINUS "
	| MULT -> print_string "MULT "
	| DIV -> print_string "DIV "
	| ASSIGNS -> print_string "ASSIGNS "
	| EQUALS -> print_string "EQUALS "
	| GTEQ -> print_string "GTEQ "
	| LTEQ -> print_string "LTEQ "
	| NE -> print_string "NE "
	| GT -> print_string "GT "
	| LT -> print_string "LT "
	| BEGIN -> print_string "BEGIN "
	| END -> print_string "END "
	| IF -> print_string "IF "
	| THEN -> print_string "THEN "
	| ELSE -> print_string "ELSE "
	| WHILE -> print_string "WHILE "
	| FOR -> print_string "FOR "
	| TYPE -> print_string "TYPE "
	| LET -> print_string "LET "
	| ANDLET -> print_string "ANDLET "
	| AND -> print_string "AND "
	| OR -> print_string "OR "
	| TO -> print_string "TO "
	| DOWNTO -> print_string "DOWNTO "
	| DO -> print_string "DO "
	| DONE -> print_string "DONE "
	| IN -> print_string "IN "
;;

exception Eof;;
exception LexError;;
let keyword_table = Hashtbl.create 53
let _ =
List.iter (fun (kwd, tok) -> Hashtbl.add keyword_table kwd tok)
[ "begin", BEGIN;
  "end", END;
  "if", IF;
  "then", THEN;
  "else", ELSE;
  "while", WHILE;
  "for", FOR;
  "type", TYPE;
  "let", LET;
  "and", ANDLET;
  "to", TO;
  "downto", DOWNTO;
  "do", DO;
  "done", DONE;
  "nil", NIL;
  "in", IN;
  "of", OF;
  "array", ARRAY;
];;


# 87 "lexer.ml"
let __ocaml_lex_tables = {
  Lexing.lex_base = 
   "\000\000\226\255\255\255\078\000\097\000\251\255\250\255\249\255\
    \247\255\002\000\033\000\003\000\240\255\239\255\238\255\237\255\
    \236\255\050\000\234\255\233\255\232\255\231\255\230\255\229\255\
    \228\255\227\255\225\255\254\255\248\255\245\255\244\255\246\255\
    \054\000\090\000\001\000\046\000\100\000\101\000\102\000\103\000\
    ";
  Lexing.lex_backtrk = 
   "\255\255\255\255\255\255\002\000\003\000\255\255\255\255\255\255\
    \255\255\012\000\013\000\014\000\255\255\255\255\255\255\255\255\
    \255\255\020\000\255\255\255\255\255\255\255\255\255\255\255\255\
    \255\255\255\255\255\255\255\255\255\255\255\255\255\255\255\255\
    \255\255\001\000\255\255\255\255\255\255\255\255\255\255\001\000\
    ";
  Lexing.lex_default = 
   "\001\000\000\000\000\000\255\255\255\255\000\000\000\000\000\000\
    \000\000\255\255\255\255\255\255\000\000\000\000\000\000\000\000\
    \000\000\255\255\000\000\000\000\000\000\000\000\000\000\000\000\
    \000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\
    \027\000\255\255\034\000\036\000\255\255\038\000\255\255\255\255\
    ";
  Lexing.lex_trans = 
   "\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\
    \000\000\002\000\002\000\000\000\000\000\000\000\000\000\000\000\
    \000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\
    \000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\
    \002\000\000\000\024\000\002\000\000\000\000\000\005\000\025\000\
    \018\000\019\000\016\000\014\000\012\000\015\000\007\000\017\000\
    \003\000\003\000\003\000\003\000\003\000\003\000\003\000\003\000\
    \003\000\003\000\011\000\013\000\010\000\008\000\009\000\031\000\
    \028\000\004\000\004\000\004\000\004\000\004\000\004\000\004\000\
    \004\000\004\000\004\000\004\000\004\000\004\000\004\000\004\000\
    \004\000\004\000\004\000\004\000\004\000\004\000\004\000\004\000\
    \004\000\004\000\004\000\022\000\027\000\023\000\029\000\030\000\
    \033\000\004\000\004\000\004\000\004\000\004\000\004\000\004\000\
    \004\000\004\000\004\000\004\000\004\000\004\000\004\000\004\000\
    \004\000\004\000\004\000\004\000\004\000\004\000\004\000\004\000\
    \004\000\004\000\004\000\020\000\006\000\021\000\003\000\003\000\
    \003\000\003\000\003\000\003\000\003\000\003\000\003\000\003\000\
    \004\000\002\000\037\000\027\000\039\000\002\000\002\000\000\000\
    \000\000\004\000\004\000\004\000\004\000\004\000\004\000\004\000\
    \004\000\004\000\004\000\000\000\000\000\000\000\000\000\000\000\
    \000\000\000\000\004\000\004\000\004\000\004\000\004\000\004\000\
    \004\000\004\000\004\000\004\000\004\000\004\000\004\000\004\000\
    \004\000\004\000\004\000\004\000\004\000\004\000\004\000\004\000\
    \004\000\004\000\004\000\004\000\000\000\000\000\000\000\000\000\
    \004\000\000\000\004\000\004\000\004\000\004\000\004\000\004\000\
    \004\000\004\000\004\000\004\000\004\000\004\000\004\000\004\000\
    \004\000\004\000\004\000\004\000\004\000\004\000\004\000\004\000\
    \004\000\004\000\004\000\004\000\000\000\000\000\000\000\000\000\
    \000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\
    \000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\
    \000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\
    \000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\
    \026\000\255\255\000\000\000\000\000\000\000\000\000\000\000\000\
    \000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\
    \000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\
    \000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\
    \000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\
    \000\000\000\000\000\000\000\000\000\000\000\000\255\255\000\000\
    \000\000\000\000\000\000\000\000\000\000\000\000\255\255\000\000\
    \000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\
    \000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\
    \000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\
    \000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\
    \000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\
    \000\000\000\000\000\000\000\000\000\000\255\255\000\000\000\000\
    ";
  Lexing.lex_check = 
   "\255\255\255\255\255\255\255\255\255\255\255\255\255\255\255\255\
    \255\255\000\000\000\000\255\255\255\255\255\255\255\255\255\255\
    \255\255\255\255\255\255\255\255\255\255\255\255\255\255\255\255\
    \255\255\255\255\255\255\255\255\255\255\255\255\255\255\255\255\
    \000\000\255\255\000\000\034\000\255\255\255\255\000\000\000\000\
    \000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\
    \000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\
    \000\000\000\000\000\000\000\000\000\000\000\000\000\000\009\000\
    \011\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\
    \000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\
    \000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\
    \000\000\000\000\000\000\000\000\017\000\000\000\010\000\010\000\
    \032\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\
    \000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\
    \000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\
    \000\000\000\000\000\000\000\000\000\000\000\000\003\000\003\000\
    \003\000\003\000\003\000\003\000\003\000\003\000\003\000\003\000\
    \004\000\033\000\035\000\036\000\037\000\038\000\039\000\255\255\
    \255\255\004\000\004\000\004\000\004\000\004\000\004\000\004\000\
    \004\000\004\000\004\000\255\255\255\255\255\255\255\255\255\255\
    \255\255\255\255\004\000\004\000\004\000\004\000\004\000\004\000\
    \004\000\004\000\004\000\004\000\004\000\004\000\004\000\004\000\
    \004\000\004\000\004\000\004\000\004\000\004\000\004\000\004\000\
    \004\000\004\000\004\000\004\000\255\255\255\255\255\255\255\255\
    \004\000\255\255\004\000\004\000\004\000\004\000\004\000\004\000\
    \004\000\004\000\004\000\004\000\004\000\004\000\004\000\004\000\
    \004\000\004\000\004\000\004\000\004\000\004\000\004\000\004\000\
    \004\000\004\000\004\000\004\000\255\255\255\255\255\255\255\255\
    \255\255\255\255\255\255\255\255\255\255\255\255\255\255\255\255\
    \255\255\255\255\255\255\255\255\255\255\255\255\255\255\255\255\
    \255\255\255\255\255\255\255\255\255\255\255\255\255\255\255\255\
    \255\255\255\255\255\255\255\255\255\255\255\255\255\255\255\255\
    \000\000\034\000\255\255\255\255\255\255\255\255\255\255\255\255\
    \255\255\255\255\255\255\255\255\255\255\255\255\255\255\255\255\
    \255\255\255\255\255\255\255\255\255\255\255\255\255\255\255\255\
    \255\255\255\255\255\255\255\255\255\255\255\255\255\255\255\255\
    \255\255\255\255\255\255\255\255\255\255\255\255\255\255\255\255\
    \255\255\255\255\255\255\255\255\255\255\255\255\035\000\255\255\
    \255\255\255\255\255\255\255\255\255\255\255\255\032\000\255\255\
    \255\255\255\255\255\255\255\255\255\255\255\255\255\255\255\255\
    \255\255\255\255\255\255\255\255\255\255\255\255\255\255\255\255\
    \255\255\255\255\255\255\255\255\255\255\255\255\255\255\255\255\
    \255\255\255\255\255\255\255\255\255\255\255\255\255\255\255\255\
    \255\255\255\255\255\255\255\255\255\255\255\255\255\255\255\255\
    \255\255\255\255\255\255\255\255\255\255\037\000\255\255\255\255\
    ";
  Lexing.lex_base_code = 
   "";
  Lexing.lex_backtrk_code = 
   "";
  Lexing.lex_default_code = 
   "";
  Lexing.lex_trans_code = 
   "";
  Lexing.lex_check_code = 
   "";
  Lexing.lex_code = 
   "";
}

let rec token lexbuf =
    __ocaml_lex_token_rec lexbuf 0
and __ocaml_lex_token_rec lexbuf __ocaml_lex_state =
  match Lexing.engine __ocaml_lex_tables __ocaml_lex_state lexbuf with
      | 0 ->
# 95 "lexer.mll"
                         (token lexbuf; (* ignore whitespaces *))
# 225 "lexer.ml"

  | 1 ->
# 96 "lexer.mll"
                    (comment lexbuf; (*skip over comments *))
# 230 "lexer.ml"

  | 2 ->
# 97 "lexer.mll"
                 (NUM(int_of_string(Lexing.lexeme lexbuf)))
# 235 "lexer.ml"

  | 3 ->
# 98 "lexer.mll"
                 (let id = Lexing.lexeme lexbuf in
		   try
		   Hashtbl.find keyword_table id
		   with Not_found ->
		   IDENT(Lexing.lexeme lexbuf))
# 244 "lexer.ml"

  | 4 ->
# 103 "lexer.mll"
                 (AND;)
# 249 "lexer.ml"

  | 5 ->
# 104 "lexer.mll"
                 (OR;)
# 254 "lexer.ml"

  | 6 ->
# 105 "lexer.mll"
                 (DOT;)
# 259 "lexer.ml"

  | 7 ->
# 106 "lexer.mll"
                 (ASSIGNS;)
# 264 "lexer.ml"

  | 8 ->
# 107 "lexer.mll"
                 (EQUALS;)
# 269 "lexer.ml"

  | 9 ->
# 108 "lexer.mll"
                 (GTEQ;)
# 274 "lexer.ml"

  | 10 ->
# 109 "lexer.mll"
                 (LTEQ;)
# 279 "lexer.ml"

  | 11 ->
# 110 "lexer.mll"
                 (NE;)
# 284 "lexer.ml"

  | 12 ->
# 111 "lexer.mll"
                 (GT;)
# 289 "lexer.ml"

  | 13 ->
# 112 "lexer.mll"
                 (LT;)
# 294 "lexer.ml"

  | 14 ->
# 113 "lexer.mll"
                 (COLON;)
# 299 "lexer.ml"

  | 15 ->
# 114 "lexer.mll"
                 (COMMA;)
# 304 "lexer.ml"

  | 16 ->
# 115 "lexer.mll"
                 (SEMICOLON;)
# 309 "lexer.ml"

  | 17 ->
# 116 "lexer.mll"
                 (PLUS;)
# 314 "lexer.ml"

  | 18 ->
# 117 "lexer.mll"
                 (MINUS;)
# 319 "lexer.ml"

  | 19 ->
# 118 "lexer.mll"
                 (MULT;)
# 324 "lexer.ml"

  | 20 ->
# 119 "lexer.mll"
                 (DIV;)
# 329 "lexer.ml"

  | 21 ->
# 120 "lexer.mll"
                 (LPAR;)
# 334 "lexer.ml"

  | 22 ->
# 121 "lexer.mll"
                 (RPAR;)
# 339 "lexer.ml"

  | 23 ->
# 122 "lexer.mll"
                 (LCURL;)
# 344 "lexer.ml"

  | 24 ->
# 123 "lexer.mll"
                 (RCURL;)
# 349 "lexer.ml"

  | 25 ->
# 124 "lexer.mll"
                 (LSQ;)
# 354 "lexer.ml"

  | 26 ->
# 125 "lexer.mll"
                 (RSQ;)
# 359 "lexer.ml"

  | 27 ->
# 126 "lexer.mll"
                 (string lexbuf;)
# 364 "lexer.ml"

  | 28 ->
# 127 "lexer.mll"
                 (char lexbuf;)
# 369 "lexer.ml"

  | 29 ->
# 128 "lexer.mll"
           (let pos= lexbuf.lex_last_pos in
            let lenleft=lexbuf.lex_buffer_len - pos in
            print_string("Error after position: ");
            print_int (Lexing.lexeme_end lexbuf);
            print_newline();
            let s = lexbuf.lex_buffer in
            print_string("Left:\n---\n"^(String.sub s pos (lenleft))^"\n---\n");
            print_newline();
            raise LexError;)
# 382 "lexer.ml"

  | 30 ->
# 137 "lexer.mll"
             (EOF)
# 387 "lexer.ml"

  | n -> lexbuf.Lexing.refill_buff lexbuf; __ocaml_lex_token_rec lexbuf n

and comment lexbuf =
    __ocaml_lex_comment_rec lexbuf 32
and __ocaml_lex_comment_rec lexbuf __ocaml_lex_state =
  match Lexing.engine __ocaml_lex_tables __ocaml_lex_state lexbuf with
      | 0 ->
# 140 "lexer.mll"
                 ((* end of comment, resume normal lexing *)
                  token lexbuf;)
# 399 "lexer.ml"

  | 1 ->
# 142 "lexer.mll"
                 (comment lexbuf;)
# 404 "lexer.ml"

  | n -> lexbuf.Lexing.refill_buff lexbuf; __ocaml_lex_comment_rec lexbuf n

and string lexbuf =
    __ocaml_lex_string_rec lexbuf 34
and __ocaml_lex_string_rec lexbuf __ocaml_lex_state =
  match Lexing.engine __ocaml_lex_tables __ocaml_lex_state lexbuf with
      | 0 ->
# 145 "lexer.mll"
                ((* cette solution ne marche pas s'il y a des "\"" inclus *)
			 STRING(String.sub 
                                (Lexing.lexeme lexbuf) 0 
                                 ((Lexing.lexeme_end lexbuf) 
                                   - (Lexing.lexeme_start lexbuf) -1));)
# 419 "lexer.ml"

  | n -> lexbuf.Lexing.refill_buff lexbuf; __ocaml_lex_string_rec lexbuf n

and char lexbuf =
    __ocaml_lex_char_rec lexbuf 35
and __ocaml_lex_char_rec lexbuf __ocaml_lex_state =
  match Lexing.engine __ocaml_lex_tables __ocaml_lex_state lexbuf with
      | 0 ->
# 151 "lexer.mll"
                    ( CHAR(match String.get (Lexing.lexeme lexbuf) 1
                           with 'n' -> '\n' 
                              | '\\' -> '\\' 
                              | _ -> failwith "Illegal escape in char expression") )
# 433 "lexer.ml"

  | 1 ->
# 155 "lexer.mll"
                    ( CHAR(String.get (Lexing.lexeme lexbuf) 0)   )
# 438 "lexer.ml"

  | n -> lexbuf.Lexing.refill_buff lexbuf; __ocaml_lex_char_rec lexbuf n

;;

# 157 "lexer.mll"
 
(* 
let _ =
try
let lexbuf = Lexing.from_channel stdin in
while true do
print_ast(token lexbuf);
(*
print_newline();
print_string "-----";
print_newline();
*)
done
with Eof ->
print_newline();
exit 0
*)

# 463 "lexer.ml"
